#include "shellbuffer.h"
#include "scene/meshnode.h"
#include "scene/textnode.h"

void ShellBuffer::toggleBuffer(){
    for(auto child : m_children){
        MeshNode* meshchild = dynamic_cast<MeshNode*>(child);
        if(meshchild)
            meshchild->toggleVisibility();
    }
}

void ShellBuffer::update()
{

}

void ShellBuffer::push(TextNode* s){
    if (m_children.size() >= m_max_size){
        m_children[m_zero_offset++] = s;
        m_zero_offset %= m_max_size;
    }else
        m_children.push_back(s);
}
